namespace Entitas {
    public partial class Entity {
        public AnArrayComponent anArray { get { return (AnArrayComponent)GetComponent(ComponentIds.AnArray); } }

        public bool hasAnArray { get { return HasComponent(ComponentIds.AnArray); } }

        public Entity AddAnArray(string[] newArray) {
            var componentPool = GetComponentPool(ComponentIds.AnArray);
            var component = (AnArrayComponent)(componentPool.Count > 0 ? componentPool.Pop() : new AnArrayComponent());
            component.array = newArray;
            return AddComponent(ComponentIds.AnArray, component);
        }

        public Entity ReplaceAnArray(string[] newArray) {
            var componentPool = GetComponentPool(ComponentIds.AnArray);
            var component = (AnArrayComponent)(componentPool.Count > 0 ? componentPool.Pop() : new AnArrayComponent());
            component.array = newArray;
            ReplaceComponent(ComponentIds.AnArray, component);
            return this;
        }

        public Entity RemoveAnArray() {
            return RemoveComponent(ComponentIds.AnArray);;
        }
    }

    public partial class Matcher {
        static IMatcher _matcherAnArray;

        public static IMatcher AnArray {
            get {
                if (_matcherAnArray == null) {
                    var matcher = (Matcher)Matcher.AllOf(ComponentIds.AnArray);
                    matcher.componentNames = ComponentIds.componentNames;
                    _matcherAnArray = matcher;
                }

                return _matcherAnArray;
            }
        }
    }
}
